import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;



public class LimitCanvas extends ScaleCanvas implements MouseListener {
    Manager M;
    SelectInteger I;

    public LimitCanvas addManager(Manager M) {
	LimitCanvas Q=this;
	Q.M=M;
	return(Q);

    }

     public LimitCanvas() {
	 addMouseListener(this);	
         I=new SelectInteger(5,5,40,20,3,1,40,1);
     }


   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      g.setColor(Color.black);
      g.fillRect(0,0,getWidth(),getHeight());
      drawBars(g);
      I.render(g,Color.blue,Color.white,Color.white);

   }




    public void drawBars(Graphics2D g) {
	int n=M.C.I[0].val;
	AffineTransform AFF0=AffineTransform.getScaleInstance(1,-1);
	AffineTransform AFF1=AffineTransform.getTranslateInstance(0,getHeight()-10);
	GeneralPath gp=new GeneralPath();
	int k0=0;
	int k1=0;
	double cut=Math.pow(.5,I.val);
        k0=PascalMath.findCutoff(n,cut);
	k1=n-2*k0+1;
	double w=1.0*getWidth()/k1;
	double h=1.0*getHeight()-15;
	double d;
	for(int i=k0;i<=n-k0;++i) {
	    int i1=i-k0;
	    int i2=i1+1;
	    d=PascalMath.normalizedChoose(n,i);
	    gp.reset();
	    gp.moveTo((float)(i1*w),0);
	    gp.lineTo((float)(i2*w),0);
	    gp.lineTo((float)(i2*w),(float)(d*h));
	    gp.lineTo((float)(i1*w),(float)(d*h));
	    gp.closePath();
	    gp.transform(AFF0);
	    gp.transform(AFF1);
	    g.setColor(Color.red);
	    g.fill(gp);
	    g.setColor(Color.orange);
	    g.draw(gp);
	}
    }





    public void mousePressed(MouseEvent e) {
    }

    public void mouseClicked(MouseEvent e) {    
         MouseData J=MouseData.process(e);
	 I.modify(J.X);
	 repaint();
    }

     public void mouseReleased(MouseEvent e) {}
     public void mouseEntered(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {}   

}
